CREATE OR REPLACE VIEW cs.command_state_v AS
  SELECT
    command_state_id,
    command_store_id,
    state_version_num,
    processing_stage_name,
    processing_stage_version_num,
    processing_stage_status_desc,
    processing_stage_event_date,
    result_message_data,
    audit_insert_date
  FROM cs.command_state;

COMMENT ON VIEW cs.command_state_v IS
'The command state objects purpose is to support the processing of the commands that conforms to CQRS or CQS design principles.
Each Command store can transition through many states';

COMMENT ON COLUMN cs.command_state_v.command_state_id IS 
'This is a UUID for the state of the command being recorded in the database.
This id will be generated by the miroservice''s application layer, and ensures uniqueness of the command within the domain.'  ;

COMMENT ON COLUMN cs.command_state_v.command_store_id IS 
'This is a UUID for the command being recorded in the database. it references the parent entity, command_store
This id will be generated by the miroservice''s application layer, and ensures uniqueness of the command within the domain.'  ;

COMMENT ON COLUMN cs.command_state_v.state_version_num IS 
'This will be simple integer value, that will start from 1.
As the command moves through the pipeline, the value in the version will be incremented by 1.
There will at least 3 stages in the pipeline. So there will be at least 3 records with version 1, 2 and 3.'  ;

COMMENT ON COLUMN cs.command_state_v.processing_stage_name IS 
'This will be a simple string value storing the name of the processing stage processing the command.'  ;

COMMENT ON COLUMN cs.command_state_v.processing_stage_version_num IS 
'This will be a simple string value storing the version number of the processing stage. As the business processes evolve the processing stages will evolve. 
 Storing the version number allows identifying the correct process pipeline stage, during replay process.'  ;
 
COMMENT ON COLUMN cs.command_state_v.processing_stage_status_desc IS 
'This will have a value of either "SUCCESS" or "FAILURE". If the pipeline has completed, it will record the status of the pipeline.'  ;

COMMENT ON COLUMN cs.command_state_v.processing_stage_event_date IS 
'This will hold the timestamp when the decision of "SUCCESS" or "FAILURE" was made, usually timestamp when processing stage finishes.' ;

COMMENT ON COLUMN cs.command_state_v.result_message_data IS 
'This field will hold structure data, e.g. JSON data, holding the result of the processing stage. 
 This field usually will be populated with Error messages when the processing stage has failed.' ;
 
COMMENT ON COLUMN cs.command_store.audit_insert_date  IS 
'The Date and Time the row was inserted into the table. ' ;
 

